@@ -5,3 +5,4 @@ testdir/
empty
rdonly
+rdwr
@@ -1,8 +1,8 @@
# SPDX-License-Identifier: GPL-2.0
CFLAGS := -static -I../../../../usr/include
-TEST_PROGS := run_empty.sh run_rdonly.sh
-TEST_GEN_FILES := init empty rdonly
+TEST_PROGS := run_empty.sh run_rdonly.sh run_rdwr.sh
+TEST_GEN_FILES := init empty rdonly rdwr
TEST_FILES := lib.sh
include ../lib.mk
@@ -61,3 +61,7 @@ run_qemu_rdonly_fat() {
$run -drive file=fat:floppy:"$1",index=0,if=floppy,readonly
}
+run_qemu_rdwr_img() {
+ detect_debug "$2"
+ $run -drive file="$1",index=0,if=floppy,format=raw
+}
new file mode 100644
@@ -0,0 +1,67 @@
+// SPDX-License-Identifier: GPL-2.0
+
+#include <fcntl.h>
+#include <unistd.h>
+#include <sys/mount.h>
+#include <errno.h>
+#include <linux/fd.h>
+#include "../kselftest_harness.h"
+
+FIXTURE(floppy) {
+ const char *dev;
+};
+
+FIXTURE_SETUP(floppy)
+{
+ int fd;
+ struct floppy_drive_params params;
+
+ self->dev = "/dev/fd0";
+ if (access(self->dev, F_OK))
+ ksft_exit_skip("No floppy device found\n");
+ if (access(self->dev, R_OK))
+ ksft_exit_skip("Floppy is not read accessible\n");
+ if (access(self->dev, W_OK))
+ ksft_exit_skip("Floppy is not write accessible\n");
+
+ fd = open("/dev/fd0", O_ACCMODE|O_NDELAY);
+ EXPECT_EQ(0, ioctl(fd, FDGETDRVPRM, ¶ms));
+ params.flags |= FD_DEBUG;
+ EXPECT_EQ(0, ioctl(fd, FDSETDRVPRM, ¶ms));
+ close(fd);
+}
+
+FIXTURE_TEARDOWN(floppy)
+{
+}
+
+TEST_F(floppy, write)
+{
+#define TEST_DATA "TEST_WRITE"
+ int fd;
+ char test[] = TEST_DATA;
+
+ fd = open(self->dev, O_RDWR);
+ ASSERT_GT(fd, 0);
+
+ ASSERT_EQ(sizeof(test), write(fd, test, sizeof(test)));
+ ASSERT_EQ(sizeof(test), read(fd, test, sizeof(test)));
+ ASSERT_NE(0, strncmp(TEST_DATA, test, sizeof(TEST_DATA)));
+
+ ASSERT_EQ(close(fd), 0);
+#undef TEST_DATA
+}
+
+TEST_F(floppy, ioctl_disk_writable)
+{
+ int fd;
+ struct floppy_drive_struct drive;
+
+ fd = open(self->dev, O_RDONLY|O_NDELAY);
+ ASSERT_GT(fd, 0);
+ ASSERT_EQ(0, ioctl(fd, FDGETDRVSTAT, &drive));
+ ASSERT_TRUE(drive.flags & FD_DISK_WRITABLE);
+ ASSERT_EQ(close(fd), 0);
+}
+
+TEST_HARNESS_MAIN
new file mode 100755
@@ -0,0 +1,22 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+
+set -e
+
+source "$(dirname $0)"/lib.sh
+
+while getopts d flag; do
+ case "${flag}" in
+ d) debug=1;;
+ esac
+done
+
+if [ -z $debug ]; then
+ trap "rm -rf testdir" EXIT
+fi
+mkdir -p testdir
+head -c 1474560 /dev/zero > testdir/floppy.raw
+
+gen_cpio_list rdwr
+gen_initrd rdwr
+run_qemu_rdwr_img testdir/floppy.raw $debug
Add basic tests for a floppy with writable disk. "rdwr" test works under following assumptions: - writable disk in "/dev/fd0" To simulate the conditions and automate the testing process there is "run_rdwr.sh". Signed-off-by: Denis Efremov <efremov@linux.com> --- tools/testing/selftests/floppy/.gitignore | 1 + tools/testing/selftests/floppy/Makefile | 4 +- tools/testing/selftests/floppy/lib.sh | 4 ++ tools/testing/selftests/floppy/rdwr.c | 67 ++++++++++++++++++++++ tools/testing/selftests/floppy/run_rdwr.sh | 22 +++++++ 5 files changed, 96 insertions(+), 2 deletions(-) create mode 100644 tools/testing/selftests/floppy/rdwr.c create mode 100755 tools/testing/selftests/floppy/run_rdwr.sh